//INTERFACCIA CLIENTE
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.border.*;
import java.lang.*;
import javax.swing.table.*;
import java.io.*;
import java.net.Socket;

import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.SocketException;
import java.net.InetAddress;
import java.net.UnknownHostException;


/****************************************************************************
**
**     Classe CLIENTEPOOL,crea un set di Clienti che richiedono aggiornamento 
**     al Server 
**
****************************************************************************/

public class ClientePool implements Runnable {
        public static int modalita = 1; //mod.  0 - STATICA
                                        //      1 - DINAMICA
        static protected String address[]=new String[2];  // indirizzi SERVER
        public Socket socketSERVER;
        ObjectOutputStream outStream;
        ObjectInputStream StreamIn;
        static int numconManager = 0;
        static int numstaticamente = 0;
        static int numconServer1 = 0;
       	static int numconServer2 = 0;
	      
        Thread t;
	      int priority;
	      int numero;

	//COSTRUTTORE
        public ClientePool(int prio,int num) throws ClassNotFoundException,InterruptedException{
        priority = prio;
        numero=num;   
        t = new Thread(this);
        t.start();
        }
        
        public void run(){
                //inizializzazione tabella indirizzi
                if (priority == 1){
                      address[0]="lab2-pc02";  //Server1
                      address[1]="lab2-pc05";  //Server2
                      }
                else {
                      address[0]="lab2-pc05";  //Server2
                      address[1]="lab2-pc02";  //Server1
                     }
                //viene creata,stat. o dinam. una connessione ad un Server
             try{
              try{
               try{  creaconnessione();
										 t.sleep(20000);
										 if (numero == 10){
		 							         System.out.println("Numero PC collegati dinamicamente:"+numconManager);
			                     System.out.println("Numero PC collegati staticamente :"+numstaticamente);
               			       System.out.println("Numero PC collegati con Server1  :"+numconServer1);
                           System.out.println("Numero PC collegati con Server2  :"+numconServer2);
										 }
										 socketSERVER.close();
               }catch(ClassNotFoundException Clnotf){}  
              }catch(InterruptedException InE){}
             }catch(IOException ioexc){}
	 } 

        //CREAZIONE CONNESSIONE
        void creaconnessione() throws ClassNotFoundException{
           int porta = 0;              //definisce la porta di comunicazione
           String indSERVER = "NACK";  //definisce l'indirizzo del SERVER

           if (modalita == 1){
                indSERVER = toMANAGER();                              // provo a connettermi
                if (indSERVER.equalsIgnoreCase("NACK")) modalita = 0; // se il manager non risponde
                                                                      // vado in mod. statica
                if (indSERVER.equalsIgnoreCase("NOSERVER")){
                        System.out.println("Th."+numero+":Il Manager  up ma non ci sono ancora Server attivi.");
                        System.out.println("Th."+numero+":Attendere e riprovare.");
                        System.exit(1);
                       }


                }
           if (modalita==0) { numstaticamente=numstaticamente+1;
           	                  indSERVER=getStaticPrimarySer();
           } else numconManager=numconManager+1; 
           if (indSERVER.equals("lab2-pc02")) porta = 54; else porta =542; // (1100 - 1200)
           Connessione Conn = toSERVER(indSERVER,porta);
           if (Conn.valido == true) {
           													 if (indSERVER.equals("lab2-pc02")) numconServer1 = numconServer1 + 1;
           													 else if (indSERVER.equals("lab2-pc05")) numconServer2 = numconServer2 + 1;
           													 
           								           socketSERVER = Conn.socket;
                                     System.out.println("Th."+numero+":Connected to "+indSERVER);
                                    }
             else if (modalita==0){System.out.println("Th."+numero+":Non sono riuscito a stabilire la connessione con il Server di default.");
                                   System.out.println("Th."+numero+":Provo a connettermi con l'altro..."); 
                                   indSERVER=getStaticSecondarySer();
                                   if (indSERVER.equals("lab2-pc02")) porta = 54; else porta =542; // (1100 - 1200)
                                   System.out.println("indSERVER: "+indSERVER+" MOD.: "+modalita+" porta: "+porta);
                                   Conn = toSERVER(indSERVER,porta);
                                   if (Conn.valido == true){
                                             if (indSERVER.equals("lab2-pc02")) numconServer1 = numconServer1 + 1;
           													 				 else if (indSERVER.equals("lab2-pc05")) numconServer2 = numconServer2 + 1;
           													         
           													         socketSERVER = Conn.socket;
                                             System.out.println("Th."+numero+":Connected to "+indSERVER);
                                             }
                                   else{System.out.println("Th."+numero+":Server entrambi spenti.");
                                   System.exit(1);                    
                                   }
                   }else {System.out.println("Th."+numero+":Il server  caduto.Riprovare");                          
                          System.exit(1); 
                          }
                    
          try{
          // CREO STREAM
          outStream = new ObjectOutputStream(socketSERVER.getOutputStream());
          StreamIn = new ObjectInputStream(socketSERVER.getInputStream());

          // MANDO RICHIESTA
          String richiesta = new String("Richiesta");
          outStream.writeObject(richiesta);
          outStream.flush();
          //System.out.println("Th."+numero+":Inviata Richiesta al Server");

          // LEGGO LA RISPOSTA DAL SERVER e AGGIORNO TABELLA
          leggiDalServer();
          }catch (IOException ex){
             System.out.println("Cliente: IOException ");
             System.exit(1);
             }

          }

        public boolean mandaAlServer(String s){
             try{
                 outStream.writeObject(s);
                 outStream.flush();
                }catch (IOException ex){
                  System.out.println("Th."+numero+":IO error in invio al Server in Cliente.mandaAlServer().");
                  return false;
                  }
             return true;
             }



        // LETTURA DI UN OGGETTO INVIATO DAL SERVER
        public boolean leggiDalServer(){
          DB     inputDB;

          try{
           try{


          // LEGGO
          Object input = StreamIn.readObject();

          // SE RICEVO UNA STRINGA:ERRORE!
          if (input instanceof String){
             System.out.println("Th."+numero+":Letto: "+input);
             }

          // SE RICEVO UN DB AGGIORNO LA TABELLA
          if (input instanceof DB){ 
                    inputDB = (DB) input;
                    System.out.println("Th."+numero+":Ricevuta una TABLE: ");
                    }
        
         return true;
          }catch (IOException ex){
             System.out.println("Th."+numero+":IO error in Cliente.leggiDalServer");
             return false;
             }
          }catch (ClassNotFoundException cnfe){
             System.out.println("Th."+numero+":C.N.F.E. error in Cliente.leggiDalServer(). Classe dell'oggetto letto sconosciuta.");
             return false;
             }

          }


        public String getStaticPrimarySer(){
        return address[0];                      
        }

        public String getStaticSecondarySer(){
        return address[1];
        }


        // PER TENTATIVO DI CONNESSIONE AL MANAGER
        // ED ACQUISIZIONE INDIRIZZO SERVER IN MOD.DINAMICA

        public String toMANAGER(){
           DatagramSocket socketMANAGER;
           int bufferLength = 256;
           byte outBuffer[];
           byte inBuffer[];
           DatagramPacket outDatagram;
           DatagramPacket inDatagram;
           String indSERVER = "";
           String data =new String("NACK");  //Valore di ritorno

           try{
             try{
                socketMANAGER = new DatagramSocket();
                inBuffer  = new byte[bufferLength];
                outBuffer = new byte[bufferLength];
                InetAddress destManagerAddress  = InetAddress.getByName("lab2-pc04");
                String destManagerHost = destManagerAddress.getHostName().trim();
                outBuffer = new byte[bufferLength];
                outBuffer = "getconn".getBytes();
                outDatagram = new DatagramPacket(outBuffer,outBuffer.length,destManagerAddress,2345);
                socketMANAGER.send(outDatagram);
                System.out.println("Th."+numero+":Sent 'getconn' to "+destManagerHost+" at port 2345.");
                inDatagram = new DatagramPacket(inBuffer,inBuffer.length);
                socketMANAGER.setSoTimeout(4000);
                socketMANAGER.receive(inDatagram);
                destManagerAddress = inDatagram.getAddress();
                destManagerHost = destManagerAddress.getHostName().trim();
                int destPort = inDatagram.getPort();
                data = new String(inDatagram.getData());
                data=data.trim();
                System.out.println("Th."+numero+":Received a datagram from MANAGER: "+data);
              

             }catch(SocketException es){
                System.out.println("Th."+numero+":Il Manager non risponde, mi accingo a  lavorare in mod. STATICA.");
                }

           }catch (IOException ex){
             System.out.println("Th."+numero+":Il Manager non risponde, mi accingo a  lavorare in mod. STATICA.");
             }
           return data;
           }


           // CONNESSIONE AL SERVER
           public Connessione toSERVER(String destServer,int port)throws ClassNotFoundException{
           Socket socketSERVER;
           int porta = port;
           InetAddress IPServer;
           Connessione conn =new Connessione();  //Valore di ritorno

           try{
             InetAddress localAddress = InetAddress.getLocalHost();
            // System.out.println("Th."+numero+":Provo a connettermi con "+destServer);

             try{
               IPServer = InetAddress.getByName(destServer);
               socketSERVER = new Socket(IPServer,porta);
               //System.out.println("Th."+numero+":Connected to: "+IPServer+" on port: "+porta);
               conn = new Connessione(socketSERVER);
               }catch (IOException ex){
                  System.out.println("Th."+numero+":IO error creating socket in Cliente.toSERVER(destServer,int)");
                  }


           }catch (UnknownHostException ex){
              System.out.println("Th."+numero+":Cliente.toServer:Unknown host");
              System.exit(1);
              }
           return conn;
           }


        // MAIN
        public static void main(String[] args) throws ClassNotFoundException,InterruptedException{
               
               int prior = 0;
               int totThread = 0;
               if (args.length!=2) {
                                     System.out.println("Uso: java Cliente prior [1-prior.to Master,2 - to Slave] [num_of_Thread]");
                                     System.exit(0);
                                    }
               try{
               prior = Integer.valueOf(args[0]).intValue();
               totThread = Integer.valueOf(args[1]).intValue();
               }catch (NumberFormatException ex){
               System.out.println("Invalid number");
               System.exit(0);
               }
               if ((prior != 1) && (prior != 2)){
                                                System.out.println("Invalid Priority number[1-prior.to Master,2 - to Slave]");
                                                System.exit(1);
                                                }
               
               for (int yyy=1;yyy<totThread + 1;yyy++)                              
               new ClientePool(prior,yyy);
               
        }            

}
