import java.io.Serializable;



/***************************************************************************
**
**        classe DB - db triviale per memorizzazione prenotazioni 
**
****************************************************************************/

class DB implements Serializable{
static int FASCIE = 8;
static int GIORNI = 6;
protected String[][] dbCAM;

//COSTRUTTORE
DB(){  
dbCAM = new String[FASCIE][GIORNI];
for(int i=0;i<FASCIE;i++)
 for (int j=0;j<GIORNI;j++)
   dbCAM[i][j] = "";

}

public static DB creacopia(DB database){
    DB copia = new DB();

    for(int i=0;i<FASCIE;i++)
     for (int j=0;j<GIORNI;j++)
     copia.dbCAM[i][j] = database.dbCAM[i][j];
   return copia;
}


public boolean inseriscipren(int time,int day,String name){
int fascia = time -1;
int giorno = day - 1;


if ((fascia<0) || (fascia>=FASCIE)) return false;
if ((giorno<0) || (giorno>=GIORNI)) return false;
dbCAM[fascia][giorno] = name;
return true;
}



public String leggipren(int fascia,int giorno){

String name = dbCAM[fascia - 1][giorno - 1];
return name;
}

public String toString(){
String r = "";
for(int i=0;i<FASCIE;i++)
 for (int j=0;j<GIORNI;j++){
   if ((String.valueOf(dbCAM[i][j])).equals("")) r += "LIBERO";
   r += String.valueOf(dbCAM[i][j])+"**";
   }
return r;
}

// DATA UNA FASCIA RESTITUISCE L'ORA
public static String convertiora(int Fascia){
String ora="";
 switch(Fascia){
  case 1: ora = "08.00";
      break;
  case 2: ora = "09.00";
      break;
  case 3: ora = "10.00";
      break;
  case 4: ora = "11.00";
      break;
  case 5: ora = "12.00";
      break;
  case 6: ora = "16.00";
      break;
  case 7: ora = "17.00";
      break;
  case 8: ora = "18.00";
      break;
  default: ora = "Sconosciuta";
 }
return ora;
}

// DATO UN GIORNO IN NUMERO LO RESTITUISCE IN STRINGA
public static String convertigiorno(int Giorno){

String giorno="";
 switch(Giorno){
  case 1: giorno = "LUNEDI'";
      break;
  case 2: giorno = "MARTEDI'";
      break;
  case 3: giorno = "MERCOLEDI'";
      break;
  case 4: giorno = "GIOVEDI'";
      break;
  case 5: giorno = "VENERDI'";
      break;
  case 6: giorno = "SABATO";
      break;
  default: giorno = "Sconosciuto";
 }
return giorno;
}

}
