import java.lang.System;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.SocketException;
import java.net.InetAddress;
import java.io.IOException;
import java.io.InterruptedIOException;
import java.util.Date;

/***************************************************************************
**
**  Classe ServertoManager2 - Thread per colloquio Server/Manager
**                            (Scambio di segnalazioni di presenza)
**
*****************************************************************************/

public class ServertoManager2 implements Runnable{

static DatagramSocket socketMANAGER; 
static int bufferLength = 256;
static byte outBuffer[];
static byte inBuffer[];
static DatagramPacket outDatagram;
static DatagramPacket inDatagram;
static InetAddress managerAddress; 
static int destPort  = 2345;
static int localPort = 2202;
Thread t;

 ServertoManager2(){
   t = new Thread(this);
   System.out.println("Thread ServertoManager2 (per ascolto dal Manager) in esecuzione");
   t.start();
  }



      public void run(){
            try{
               // DA CAMBIARE PER PIU' MACCHINE
               managerAddress = InetAddress.getByName("lab2-pc04");
               String risposta = ""; // stringa di risposta
               String data ="";      // stringa di ingresso

                // MI SEGNALO AL MANAGER
                socketMANAGER = new DatagramSocket(localPort);
                inBuffer  = new byte[bufferLength];
                invioalManager("Start");
                inDatagram = new DatagramPacket(inBuffer,inBuffer.length);

                //ATTENDO LA RISPOSTA DAL MANAGER SE UP
                try{
                   socketMANAGER.setSoTimeout(5000);
                   socketMANAGER.receive(inDatagram);
                   InetAddress destAddress = inDatagram.getAddress();
                   String destHost = destAddress.getHostName().trim();
                   int destPort = inDatagram.getPort();
                   data = new String(inDatagram.getData());
                   data=data.trim();
                   System.out.println("ServertoManager2:Received "+data+" from "+destHost+" (Manager) at port "+destPort+".");
                   }catch(InterruptedIOException es){
                        System.out.println("ServertoManager2:TIME-OUT scaduto:Il MANAGER non risponde");
                        }

                   //CHIUDO E RIAPRO
                   socketMANAGER.close();
                   socketMANAGER = new DatagramSocket(localPort);

                // MI METTO IN ASCOLTO DEL MANAGER
                do {
                   inBuffer = new byte[bufferLength];    //Vuoto il Buffer precedente per evitare sovrapposizioni
                   inDatagram = new DatagramPacket(inBuffer,inBuffer.length);
                   System.out.println("ServertoManager2:Waiting for Manager....."); 
                   socketMANAGER.receive(inDatagram);
                   InetAddress destAddress = inDatagram.getAddress();
                   data = new String(inDatagram.getData()).trim();
                   System.out.println("ServertoManager2: Received "+data+" from "+destAddress+" (Manager).");

                   if (destAddress.equals(managerAddress))
                          if(data.equalsIgnoreCase("Start")){
                                           risposta = "OKSLAVE"+Server2.numClientAccepted;
                                           invioalManager(risposta);
                                           }
                          else System.out.println("ServertoManager2:Attenzione ricevuto "+data+":Non di protocollo");
                   } while(true);

              }catch (IOException ex){
                System.out.println("ServertoManager2:IOException occurred.");
                }
        }



  public boolean invioalManager(String s){
  try {
      outBuffer = new byte[bufferLength];
      outBuffer = s.getBytes();
      outDatagram = new DatagramPacket(outBuffer,outBuffer.length,managerAddress,2345);
      socketMANAGER.send(outDatagram);
      System.out.println("ServertoManager2:Sent "+s+" to Manager at port 2345.");
      }catch(IOException ioe){
        System.out.println("ServerToManager:IOexception during send");
        return false;
       }
  return true;

  }


}