import java.net.UnknownHostException;
import java.net.SocketException;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.ServerSocket;
import java.net.InetAddress;
import java.lang.System;
import java.net.Socket;
import java.io.*;



/***************************************************************************
**
**       class ServertoServer - thread che implementa una ServerSocket   
**        per la ricezione di messaggi             
**
***************************************************************************/

class ServertoServer implements Runnable{
static boolean creataconnessione = false;
ServerSocket  sockSERVER;     // Socket come Server
ObjectInputStream StreamINput;
ObjectOutputStream StreamOUTput;

Thread t;

Socket Cliente;      // Socket accettata




ServertoServer(){
t = new Thread(this);
System.out.println("Sono in ServertoServer");
t.start();
}


public void run(){

 try{
    creaAscolto();
 }catch(ClassNotFoundException CNFE){
  }

}

      //  RICEZIONE DI UN MESSAGGIO - AGGIORNAMENTO DELLA TABELLA
      //  TRASMISSIONE ALL'ALTRO SERVER

      public void Ricevi() throws ClassNotFoundException{

          try{
            // LEGGO E VEDO IL TIPO DI RICHIESTA: Start o Aggiorna
           
            System.out.println("ServerToServer:Waiting for request...");
            Object inLine = StreamINput.readObject();
            System.out.println("ServerToServer:Letto :"+inLine);


                 // CASO Start: RISPONDO CON TABELLA AGGIORNATA
            if (inLine instanceof String){

               if(((String) inLine).equalsIgnoreCase("Start")){

                  // LO SLAVE E' UP QUINDI MI CONNETTO DOVE LUI ASCOLTA
                  Server1.ConnToSlave();

                  DB APPOGGIO = DB.creacopia(Server1.camerino1);
                  System.out.println("ServerToServer:Letto = "+APPOGGIO);
                  StreamOUTput.writeObject(APPOGGIO);
                  StreamOUTput.flush();
                  System.out.println("ServerToServer:Sent: "+APPOGGIO);

                  }

               else System.out.println("ServerToServer: letta Stringa non di protocollo");
            }

            else

                //  CASO  CHE LEGGO UNA TABELLA: RISPONDO CON OK
            if (inLine instanceof DB){
                  DB DBAgg= (DB) inLine;
                  String Message = "Default";
                  String nomeappoggio;
                  boolean possibilepren = true;
                  System.out.println("ServerToServer:Letta InLIne: "+DBAgg);

                  // CONTROLLO CHE LA PRENOTAZIONE SIA EFFETTUABILE
                  synchronized(Server1.camerino1){
                        for(int i=0;i<8;++i)
                           for(int j=0;j<6;++j){
                                nomeappoggio = DBAgg.leggipren(i+1,j+1);
                                        if (!(nomeappoggio.equals("")))
                                           if (!((Server1.camerino1).leggipren(i+1,j+1)).equals("")){
                                                  Message = "ERRORE!! Fascia "+DB.convertigiorno(j+1)+"-"+DB.convertiora(i+1)+" gia' prenotata. CONTROLLA!";
                                                  possibilepren=false;
                                                  }
                                }//chiudo for

                        if (possibilepren){
                            // AGGIORNA LA TABELLA LOCALE
                          for(int i=0;i<8;++i)
                             for(int j=0;j<6;++j){
                                   nomeappoggio = DBAgg.leggipren(i+1,j+1);
                                   if (!(nomeappoggio.equals("")))
                                          (Server1.camerino1).inseriscipren(i+1,j+1,nomeappoggio);
                                   }//chiudo for
                          StreamOUTput.writeObject("OK");
                          StreamOUTput.flush();
                          System.out.println("ServerToServer:Sent: OK");
                        }//chiudo if
                        else{
                          StreamOUTput.writeObject(Message);
                          StreamOUTput.flush();
                          System.out.println("ServerToServer:Sent: "+Message);
                          }

                       }//chiudo synchronized

                 
            }

            else{
                 // CASO DI OGGETTO NON IDENTIFICATO
                 System.out.println("ServerToServer:Letto oggetto non identificato");

            }
          }catch(IOException ioe){
          System.out.println("ServerToServer:SLAVE DOWN");
          Server1.unicoserver = true;
          Server1.StoM.invioalManager("SLAVE DOWN");
          }
      }// FINE - Ricevi()

      // CHIUSURA DELLA CONNESSIONE
      public void shutdown(Socket s){
      try{
       s.close();
       }catch (IOException ex2){
          System.out.println("IO error closing socket in Thread ServertoServer");
          System.exit(1);
          }
      }


  // CREO UNA CONNESSIONE DI ASCOLTO
  public void creaAscolto() throws ClassNotFoundException{

   try{

       sockSERVER = new ServerSocket(2301);
       int localPort = sockSERVER.getLocalPort();
    do{
       System.out.println("Server1 is already and listening for Server Slave on port "+localPort+".");
       // CICLO INFINITO: OGNI VOLTA CHE SERVER2 CADE CERCO DI RECUPERARLO
      try{
       Cliente  = sockSERVER.accept();
       System.out.println("Slave accepted.");
       Server1.unicoserver = false;
       StreamINput = new ObjectInputStream(Cliente.getInputStream());
       StreamOUTput = new ObjectOutputStream(Cliente.getOutputStream());
      
       do{
          Ricevi();
       }while(!(Server1.unicoserver));

      }catch (IOException ex){
        Server1.unicoserver = true;
        System.out.println("Il Server Slave  DOWN");
        shutdown(Cliente);
        // INVIO MESSAGGIO AL MANAGER  ??
       }

    }while(true);
       
   
     }catch (IOException ex2){
       Server1.unicoserver = true;
       System.out.println("IO exception in ServerToServer");
       }

}

}

