import java.net.UnknownHostException;
import java.net.SocketException;
import java.net.DatagramSocket;
import java.net.DatagramPacket;
import java.net.ServerSocket;
import java.net.InetAddress;
import java.lang.System;
import java.net.Socket;
import java.io.*;



/***************************************************************************
**
**       class ServertoServer2 - thread che implementa una ServerSocket   
**        per la ricezione di messaggi             
**
***************************************************************************/

class ServertoServer2 implements Runnable{
static boolean creataconnessione = false;
ServerSocket  sockSERVER;     // Socket come Server
ObjectInputStream StreamIngresso;
ObjectOutputStream StreamUscita;

Thread t;

Socket Cliente;      // Socket accettata




ServertoServer2(){
t = new Thread(this);
System.out.println("Thread ServertoServer2 (per ascolto dal Master) in esecuzione");
t.start();
}

// Scrivere un metodo per leggere dallo stream

public void run(){

 try{
    creaAscolto();
 }catch(ClassNotFoundException CNFE){
  }

}

      //  RICEZIONE DI UN MESSAGGIO - AGGIORNAMENTO DELLA TABELLA
      //  TRASMISSIONE ALL'ALTRO SERVER

      public void Ricevi() throws ClassNotFoundException{

          try{
            // LEGGO E VEDO IL TIPO DI RICHIESTA: Start o Aggiorna
           
            System.out.println("ServerToServer2:Waiting for request...");
            Object inLine = StreamIngresso.readObject();

                 // CASO Start: RISPONDO CON TABELLA AGGIORNATA
            if (inLine instanceof String){

               if(((String) inLine).equalsIgnoreCase("Start")){

                  // IL MASTER E' UP QUINDI MI CONNETTO DOVE LUI ASCOLTA
                  Server2.ConnToMaster();


                  System.out.println("ServerToServer2:Ricevuto 'Start' dal Master");
                  DB APPOGGIO = DB.creacopia(Server2.camerino1);
                  StreamUscita.writeObject(APPOGGIO);
                  StreamUscita.flush();
                  System.out.println("ServerToServer2:Sent al Master:"+APPOGGIO);
                  }

               else System.out.println("ServerToServer2: letta Stringa non di protocollo dal Master");
            }

            else

                //  CASO  CHE LEGGO UNA TABELLA: RISPONDO CON OK
            if (inLine instanceof DB){
                  DB DBAgg= (DB) inLine;
                  String Message = "Default";
                  String nomeappoggio;
                  boolean possibilepren = true;
                  System.out.println("ServerToServer2:Ricevuta dal Master tab. di pren: "+DBAgg);

                  // CONTROLLO CHE LA PRENOTAZIONE SIA EFFETTUABILE
                  synchronized(Server2.camerino1){
                        for(int i=0;i<8;++i)
                           for(int j=0;j<6;++j){
                                nomeappoggio = DBAgg.leggipren(i+1,j+1);
                                        if (!(nomeappoggio.equals("")))
                                           if (!((Server2.camerino1).leggipren(i+1,j+1)).equals("")){
                                                  Message = "ERRORE!! Fascia "+DB.convertigiorno(j+1)+"-"+DB.convertiora(i+1)+" gia' prenotata. CONTROLLA!";
                                                  possibilepren=false;
                                                  }
                                }//chiudo for

                        if (possibilepren){
                                // AGGIORNA LA TABELLA LOCALE
                                for(int i=0;i<8;++i)
                                     for(int j=0;j<6;++j){
                                           nomeappoggio = DBAgg.leggipren(i+1,j+1);
                                           if (!(nomeappoggio.equals("")))
                                                (Server2.camerino1).inseriscipren(i+1,j+1,nomeappoggio);
                                           }//chiudo for
                                StreamUscita.writeObject("OK");
                                StreamUscita.flush();
                                System.out.println("ServerToServer2:Sentto Master: OK");
                                }//chiudo if
                        else{
                          StreamUscita.writeObject(Message);
                          StreamUscita.flush();
                          System.out.println("ServerToServer2:Sent to Master:"+Message);
                          }
                        }//chiudo synchronized

                 
            }

            else{
                 // CASO DI OGGETTO NON IDENTIFICATO
                 System.out.println("ServerToServer2: Letto oggetto non identificato dal Master");
            }
          }catch(IOException ioe){
          System.out.println("ServerToServer2: - MASTER DOWN");
          Server2.unicoserver = true;
          Server2.StoM.invioalManager("MASTER DOWN");

          }
      }// FINE - Ricevi()

      // CHIUSURA DELLA CONNESSIONE
      public void shutdown(Socket s){
      try{
       s.close();
       }catch (IOException ex2){
          System.out.println("IO error closing socket in Thread ServertoServer2");
          System.exit(1);
          }
      }


  // CREO UNA CONNESSIONE DI ASCOLTO
  public void creaAscolto() throws ClassNotFoundException{

   try{

       sockSERVER = new ServerSocket(2302);
       int localPort = sockSERVER.getLocalPort();

    do{
       System.out.println("ServerToServer2:Slave is already and listening for Server Master on port "+localPort+".");
       // CICLO INFINITO: OGNI VOLTA CHE SERVER2 CADE CERCO DI RECUPERARLO
      try{
       Cliente  = sockSERVER.accept();
       System.out.println("ServerToServer2:Master accepted.");
       Server2.unicoserver = false;
       StreamIngresso = new ObjectInputStream(Cliente.getInputStream());
       StreamUscita   = new ObjectOutputStream(Cliente.getOutputStream());
      
       do{
          Ricevi();
       }while(!(Server2.unicoserver));

      }catch (IOException ex){
        Server2.unicoserver = true;
        System.out.println("ServerToServer2:Il Server Master  DOWN");
        shutdown(Cliente);
       }

    }while(true);
       
   
     }catch (IOException ex2){
       Server2.unicoserver = true;
       System.out.println("IO exception in ServerToServer2");
       }

}


}


